<?php
/**
 * @category   Alogic
 * @package    Alogic_Distributors
 * @author     dushyantjoshia@gmail.com
 * @copyright  This file was generated by using Module Creator(http://code.vky.co.in/magento-2-module-creator/) provided by VKY <viky.031290@gmail.com>
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */

namespace Alogic\Distributors\Block;

use Magento\Framework\View\Element\Template\Context;
use Alogic\Distributors\Model\DistributorsFactory;
/**
 * Distributors List block
 */
class DistributorsListData extends \Magento\Framework\View\Element\Template
{
    /**
     * @var Distributors
     */
    protected $_distributors;
    public function __construct(
        Context $context,
        DistributorsFactory $distributors
    ) {
        $this->_distributors = $distributors;
        parent::__construct($context);
    }

    public function _prepareLayout()
    {
        $this->pageConfig->getTitle()->set(__('Alogic Distributors Module List Page'));
        
        if ($this->getDistributorsCollection()) {
            $pager = $this->getLayout()->createBlock(
                'Magento\Theme\Block\Html\Pager',
                'alogic.distributors.pager'
            )->setAvailableLimit(array(5=>5,10=>10,15=>15))->setShowPerPage(true)->setCollection(
                $this->getDistributorsCollection()
            );
            $this->setChild('pager', $pager);
            $this->getDistributorsCollection()->load();
        }
        return parent::_prepareLayout();
    }

    public function getDistributorsCollection()
    {
        $page = ($this->getRequest()->getParam('p'))? $this->getRequest()->getParam('p') : 1;
        $pageSize = ($this->getRequest()->getParam('limit'))? $this->getRequest()->getParam('limit') : 5;

        $distributors = $this->_distributors->create();
        $collection = $distributors->getCollection();
        $collection->addFieldToFilter('status','1');
        //$distributors->setOrder('distributors_id','ASC');
        $collection->setPageSize($pageSize);
        $collection->setCurPage($page);

        return $collection;
    }

    public function getPagerHtml()
    {
        return $this->getChildHtml('pager');
    }
}